// BossSeeClientView.h : interface of the CBossSeeClientView class
//
/////////////////////////////////////////////////////////////////////////////
/***************************************************************************
 *        Module               :                             *
 *        
 *                                                                         *
 *        Created by           : ??      Date  : 2004.9.12        *
 *        Modified by          :                  Date  :                  *
 *                                                                         * 
 *                   * 
 ***************************************************************************/
#if !defined(AFX_BOSSSEECLIENTVIEW_H__B8235A12_5B66_4FF4_8566_AF90FC983EB4__INCLUDED_)
#define AFX_BOSSSEECLIENTVIEW_H__B8235A12_5B66_4FF4_8566_AF90FC983EB4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CBossSeeClientView : public CTreeView
{
protected: // create from serialization only
	CBossSeeClientView();
	DECLARE_DYNCREATE(CBossSeeClientView)

// Attributes
public:
	CBossSeeClientDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBossSeeClientView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void OnMyHelp();
	void OnKill();
	HTREEITEM m_hTreeItemLastSel;
	CString m_strSelIP;
	CImageList il;
	
	virtual ~CBossSeeClientView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
   
       CSocket* m_pRecBMPSocket;
// Generated message map functions
protected:
	int m_iTimer;
	//{{AFX_MSG(CBossSeeClientView)
	afx_msg void OnGetScreen();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAddIp();
	afx_msg void OnRclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeleteItemcomputer();
	afx_msg void OnConfigSelcomputer();
	afx_msg void OnStop();
	afx_msg void OnStart();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BossSeeClientView.cpp
inline CBossSeeClientDoc* CBossSeeClientView::GetDocument()
   { return (CBossSeeClientDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BOSSSEECLIENTVIEW_H__B8235A12_5B66_4FF4_8566_AF90FC983EB4__INCLUDED_)
